`include "traffic.v"

module test();
wire HR, HY, HG, FR, FY, FG;
reg reset, C, clock;
reg [2:0] HL;
reg [2:0] FL;
wire ST;


Timer part1(TS, TL, ST, clock);
FSM part2(HR, HY, HG, FR, FY, FG, ST, TS, TL, C, reset, clock);

initial begin
    $dumpfile("test.vcd");
    $dumpvars(0,test);
    reset = 1'b0;
    C = 1'b0;
    clock = 1'b0;
    $monitor("TIME = %d, reset = %b, C = %b, ST = %b, HL = %3b, FL = %3b",$time,reset,C,ST,HL,FL);

    #1 reset = 1;
    #5 reset = 0;
    #150 C = 1;
    #250 C = 0;
    #260 C = 1;
    #140 C = 0;
    #200 $finish;
end

always
    #2 clock = ~clock;

always @ (HR,HY,HG,FR,FY,FG) begin
    HL = {HR,HY,HG};
    FL = {FR,FY,FG};
end

endmodule
